<?php
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                   ATTENTION!
 * If you see this message in your browser (Internet Explorer, Mozilla Firefox, Google Chrome, etc.)
 * this means that PHP is not properly installed on your web server. Please refer to the PHP manual
 * for more details: http://php.net/manual/install.php 
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

    include_once dirname(__FILE__) . '/components/startup.php';
    include_once dirname(__FILE__) . '/components/application.php';
    include_once dirname(__FILE__) . '/' . 'authorization.php';


    include_once dirname(__FILE__) . '/' . 'database_engine/mysql_engine.php';
    include_once dirname(__FILE__) . '/' . 'components/page/page_includes.php';

    function GetConnectionOptions()
    {
        $result = GetGlobalConnectionOptions();
        $result['client_encoding'] = 'utf8';
        GetApplication()->GetUserAuthentication()->applyIdentityToConnectionOptions($result);
        return $result;
    }

    
    
    
    // OnBeforePageExecute event handler
    
    
    
    class is_ttr_certificado_third_eyePage extends Page
    {
        protected function DoBeforeCreate()
        {
            $this->SetTitle('');
            $this->SetMenuLabel('Certificado Tercer Ojo');
            $this->SetHeader(GetPagesHeader());
            $this->SetFooter(GetPagesFooter());
    
            $this->dataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_ttr_certificado_third_eye`');
            $this->dataset->addFields(
                array(
                    new IntegerField('id', true, true, true),
                    new IntegerField('id_empresa', true),
                    new DateTimeField('registro', true),
                    new StringField('enabled_certificado_third_eye', true),
                    new StringField('patente_vehiculo'),
                    new StringField('modelo_vehiculo'),
                    new DateField('instalacion', true),
                    new DateField('calibracion'),
                    new DateField('caduca', true),
                    new StringField('codigo_fabrica'),
                    new IntegerField('certificado_third_eye', true),
                    new IntegerField('third_eye_type_id', true)
                )
            );
            $this->dataset->AddLookupField('third_eye_type_id', 'is_tpa_third_eye_type', new IntegerField('third_eye_type_id'), new StringField('descripcion', false, false, false, false, 'third_eye_type_id_descripcion', 'third_eye_type_id_descripcion_is_tpa_third_eye_type'), 'third_eye_type_id_descripcion_is_tpa_third_eye_type');
            $this->dataset->AddLookupField('enabled_certificado_third_eye', 'is_tpa_enabled_certificado_third_eye', new StringField('enabled_certificado_third_eye'), new StringField('descripcion', false, false, false, false, 'enabled_certificado_third_eye_descripcion', 'enabled_certificado_third_eye_descripcion_is_tpa_enabled_certificado_third_eye'), 'enabled_certificado_third_eye_descripcion_is_tpa_enabled_certificado_third_eye');
            $this->dataset->AddLookupField('id_empresa', 'is_tpa_empresa', new IntegerField('id_empresa'), new StringField('empresa', false, false, false, false, 'id_empresa_empresa', 'id_empresa_empresa_is_tpa_empresa'), 'id_empresa_empresa_is_tpa_empresa');
            $this->dataset->AddCustomCondition(EnvVariablesUtils::EvaluateVariableTemplate($this->GetColumnVariableContainer(), '`is_ttr_certificado_third_eye`.id_empresa = 8'));
        }
    
        protected function DoPrepare() {
    
        }
    
        protected function CreatePageNavigator()
        {
            $result = new CompositePageNavigator($this);
            
            $partitionNavigator = new PageNavigator('pnav', $this, $this->dataset);
            $partitionNavigator->SetRowsPerPage(12);
            $result->AddPageNavigator($partitionNavigator);
            
            return $result;
        }
    
        protected function CreateRssGenerator()
        {
            return null;
        }
    
        protected function setupCharts()
        {
    
        }
    
        protected function getFiltersColumns()
        {
            return array(
                new FilterColumn($this->dataset, 'patente_vehiculo', 'patente_vehiculo', 'Patente Vehículo'),
                new FilterColumn($this->dataset, 'modelo_vehiculo', 'modelo_vehiculo', 'Modelo Vehículo'),
                new FilterColumn($this->dataset, 'third_eye_type_id', 'third_eye_type_id_descripcion', 'Tipo de Tercer Ojo'),
                new FilterColumn($this->dataset, 'instalacion', 'instalacion', 'Fecha Instalación'),
                new FilterColumn($this->dataset, 'calibracion', 'calibracion', 'Fecha de Calibración'),
                new FilterColumn($this->dataset, 'caduca', 'caduca', 'Fecha de Expiración'),
                new FilterColumn($this->dataset, 'codigo_fabrica', 'codigo_fabrica', 'Código Fabrica'),
                new FilterColumn($this->dataset, 'registro', 'registro', 'Registro'),
                new FilterColumn($this->dataset, 'enabled_certificado_third_eye', 'enabled_certificado_third_eye_descripcion', 'Habilitado'),
                new FilterColumn($this->dataset, 'certificado_third_eye', 'certificado_third_eye', 'Certificado'),
                new FilterColumn($this->dataset, 'id', 'id', 'Id'),
                new FilterColumn($this->dataset, 'id_empresa', 'id_empresa_empresa', 'Id Empresa')
            );
        }
    
        protected function setupQuickFilter(QuickFilter $quickFilter, FixedKeysArray $columns)
        {
            $quickFilter
                ->addColumn($columns['patente_vehiculo'])
                ->addColumn($columns['modelo_vehiculo'])
                ->addColumn($columns['third_eye_type_id'])
                ->addColumn($columns['instalacion'])
                ->addColumn($columns['calibracion'])
                ->addColumn($columns['caduca'])
                ->addColumn($columns['codigo_fabrica'])
                ->addColumn($columns['registro'])
                ->addColumn($columns['enabled_certificado_third_eye'])
                ->addColumn($columns['certificado_third_eye'])
                ->addColumn($columns['id'])
                ->addColumn($columns['id_empresa']);
        }
    
        protected function setupColumnFilter(ColumnFilter $columnFilter)
        {
    
        }
    
        protected function setupFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
    
        }
    
        protected function AddOperationsColumns(Grid $grid)
        {
    
        }
    
        protected function AddFieldColumns(Grid $grid, $withDetails = true)
        {
            //
            // View column for patente_vehiculo field
            //
            $column = new TextViewColumn('patente_vehiculo', 'patente_vehiculo', 'Patente Vehículo', $this->dataset);
            $column->SetOrderable(true);
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for modelo_vehiculo field
            //
            $column = new TextViewColumn('modelo_vehiculo', 'modelo_vehiculo', 'Modelo Vehículo', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for descripcion field
            //
            $column = new TextViewColumn('third_eye_type_id', 'third_eye_type_id_descripcion', 'Tipo de Tercer Ojo', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for instalacion field
            //
            $column = new DateTimeViewColumn('instalacion', 'instalacion', 'Fecha Instalación', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('Y-m-d');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for calibracion field
            //
            $column = new DateTimeViewColumn('calibracion', 'calibracion', 'Fecha de Calibración', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('d-m-Y');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for caduca field
            //
            $column = new DateTimeViewColumn('caduca', 'caduca', 'Fecha de Expiración', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('Y-m-d');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for codigo_fabrica field
            //
            $column = new TextViewColumn('codigo_fabrica', 'codigo_fabrica', 'Código Fabrica', $this->dataset);
            $column->setNullLabel('');
            $column->SetOrderable(true);
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for registro field
            //
            $column = new DateTimeViewColumn('registro', 'registro', 'Registro', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('d-m-Y H:i:s');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for descripcion field
            //
            $column = new TextViewColumn('enabled_certificado_third_eye', 'enabled_certificado_third_eye_descripcion', 'Habilitado', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for certificado_third_eye field
            //
            $column = new TextViewColumn('certificado_third_eye', 'certificado_third_eye', 'Certificado', $this->dataset);
            $column->SetOrderable(true);
            $column->setHrefTemplate('https://forte.isanto.cl:8443/EmiteCertificado/view/thirdEye/CertificadoTercerOjo?id=%id%');
            $column->setTarget('_self');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
        }
    
        protected function AddSingleRecordViewColumns(Grid $grid)
        {
            //
            // View column for patente_vehiculo field
            //
            $column = new TextViewColumn('patente_vehiculo', 'patente_vehiculo', 'Patente Vehículo', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for modelo_vehiculo field
            //
            $column = new TextViewColumn('modelo_vehiculo', 'modelo_vehiculo', 'Modelo Vehículo', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for descripcion field
            //
            $column = new TextViewColumn('third_eye_type_id', 'third_eye_type_id_descripcion', 'Tipo de Tercer Ojo', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for instalacion field
            //
            $column = new DateTimeViewColumn('instalacion', 'instalacion', 'Fecha Instalación', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('Y-m-d');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for calibracion field
            //
            $column = new DateTimeViewColumn('calibracion', 'calibracion', 'Fecha de Calibración', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('d-m-Y');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for caduca field
            //
            $column = new DateTimeViewColumn('caduca', 'caduca', 'Fecha de Expiración', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('Y-m-d');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for codigo_fabrica field
            //
            $column = new TextViewColumn('codigo_fabrica', 'codigo_fabrica', 'Código Fabrica', $this->dataset);
            $column->setNullLabel('');
            $column->SetOrderable(true);
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for registro field
            //
            $column = new DateTimeViewColumn('registro', 'registro', 'Registro', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('d-m-Y H:i:s');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for descripcion field
            //
            $column = new TextViewColumn('enabled_certificado_third_eye', 'enabled_certificado_third_eye_descripcion', 'Habilitado', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for certificado_third_eye field
            //
            $column = new TextViewColumn('certificado_third_eye', 'certificado_third_eye', 'Certificado', $this->dataset);
            $column->SetOrderable(true);
            $column->setHrefTemplate('https://forte.isanto.cl:8443/EmiteCertificado/view/thirdEye/CertificadoTercerOjo?id=%id%');
            $column->setTarget('_self');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for id field
            //
            $column = new NumberViewColumn('id', 'id', 'Id', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator(',');
            $column->setDecimalSeparator('');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for empresa field
            //
            $column = new TextViewColumn('id_empresa', 'id_empresa_empresa', 'Id Empresa', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddSingleRecordViewColumn($column);
        }
    
        protected function AddEditColumns(Grid $grid)
        {
            //
            // Edit column for patente_vehiculo field
            //
            $editor = new TextEdit('patente_vehiculo_edit');
            $editor->SetMaxLength(7);
            $editColumn = new CustomEditColumn('Patente Vehículo', 'patente_vehiculo', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for modelo_vehiculo field
            //
            $editor = new TextAreaEdit('modelo_vehiculo_edit', 50, 8);
            $editColumn = new CustomEditColumn('Modelo Vehículo', 'modelo_vehiculo', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for third_eye_type_id field
            //
            $editor = new DynamicCombobox('third_eye_type_id_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_third_eye_type`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('third_eye_type_id', true, true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Tipo de Tercer Ojo', 'third_eye_type_id', 'third_eye_type_id_descripcion', 'edit_is_ttr_certificado_third_eye_third_eye_type_id_search', $editor, $this->dataset, $lookupDataset, 'third_eye_type_id', 'descripcion', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for instalacion field
            //
            $editor = new DateTimeEdit('instalacion_edit', false, 'd-m-Y');
            $editColumn = new CustomEditColumn('Fecha Instalación', 'instalacion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for calibracion field
            //
            $editor = new DateTimeEdit('calibracion_edit', false, 'd-m-Y');
            $editColumn = new CustomEditColumn('Fecha de Calibración', 'calibracion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for caduca field
            //
            $editor = new DateTimeEdit('caduca_edit', false, 'd-m-Y');
            $editColumn = new CustomEditColumn('Fecha de Expiración', 'caduca', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for codigo_fabrica field
            //
            $editor = new TextEdit('codigo_fabrica_edit');
            $editor->SetMaxLength(20);
            $editColumn = new CustomEditColumn('Código Fabrica', 'codigo_fabrica', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for registro field
            //
            $editor = new DateTimeEdit('registro_edit', false, 'd-m-Y H:i:s');
            $editColumn = new CustomEditColumn('Registro', 'registro', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for enabled_certificado_third_eye field
            //
            $editor = new DynamicCombobox('enabled_certificado_third_eye_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_enabled_certificado_third_eye`');
            $lookupDataset->addFields(
                array(
                    new StringField('enabled_certificado_third_eye', true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Habilitado', 'enabled_certificado_third_eye', 'enabled_certificado_third_eye_descripcion', 'edit_is_ttr_certificado_third_eye_enabled_certificado_third_eye_search', $editor, $this->dataset, $lookupDataset, 'enabled_certificado_third_eye', 'descripcion', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for certificado_third_eye field
            //
            $editor = new TextEdit('certificado_third_eye_edit');
            $editColumn = new CustomEditColumn('Certificado', 'certificado_third_eye', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for id_empresa field
            //
            $editor = new DynamicCombobox('id_empresa_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_empresa`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id_empresa', true, true),
                    new StringField('empresa'),
                    new StringField('razon_social'),
                    new StringField('rut'),
                    new StringField('direccion'),
                    new StringField('telefono_empresa'),
                    new StringField('enabled_empresa'),
                    new DateTimeField('registro'),
                    new DateTimeField('ingreso'),
                    new StringField('nombre_contacto'),
                    new StringField('telefono_contacto'),
                    new IntegerField('user_id_default'),
                    new IntegerField('monto_deuda'),
                    new StringField('notificacion_sistema'),
                    new StringField('notificacion_email')
                )
            );
            $lookupDataset->setOrderByField('empresa', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Id Empresa', 'id_empresa', 'id_empresa_empresa', 'edit_is_ttr_certificado_third_eye_id_empresa_search', $editor, $this->dataset, $lookupDataset, 'id_empresa', 'empresa', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
        }
    
        protected function AddMultiEditColumns(Grid $grid)
        {
            //
            // Edit column for patente_vehiculo field
            //
            $editor = new TextEdit('patente_vehiculo_edit');
            $editor->SetMaxLength(7);
            $editColumn = new CustomEditColumn('Patente Vehículo', 'patente_vehiculo', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for modelo_vehiculo field
            //
            $editor = new TextAreaEdit('modelo_vehiculo_edit', 50, 8);
            $editColumn = new CustomEditColumn('Modelo Vehículo', 'modelo_vehiculo', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for third_eye_type_id field
            //
            $editor = new DynamicCombobox('third_eye_type_id_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_third_eye_type`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('third_eye_type_id', true, true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Tipo de Tercer Ojo', 'third_eye_type_id', 'third_eye_type_id_descripcion', 'multi_edit_is_ttr_certificado_third_eye_third_eye_type_id_search', $editor, $this->dataset, $lookupDataset, 'third_eye_type_id', 'descripcion', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for instalacion field
            //
            $editor = new DateTimeEdit('instalacion_edit', false, 'd-m-Y');
            $editColumn = new CustomEditColumn('Fecha Instalación', 'instalacion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for calibracion field
            //
            $editor = new DateTimeEdit('calibracion_edit', false, 'd-m-Y');
            $editColumn = new CustomEditColumn('Fecha de Calibración', 'calibracion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for caduca field
            //
            $editor = new DateTimeEdit('caduca_edit', false, 'd-m-Y');
            $editColumn = new CustomEditColumn('Fecha de Expiración', 'caduca', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for codigo_fabrica field
            //
            $editor = new TextEdit('codigo_fabrica_edit');
            $editor->SetMaxLength(20);
            $editColumn = new CustomEditColumn('Código Fabrica', 'codigo_fabrica', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for registro field
            //
            $editor = new DateTimeEdit('registro_edit', false, 'd-m-Y H:i:s');
            $editColumn = new CustomEditColumn('Registro', 'registro', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for enabled_certificado_third_eye field
            //
            $editor = new DynamicCombobox('enabled_certificado_third_eye_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_enabled_certificado_third_eye`');
            $lookupDataset->addFields(
                array(
                    new StringField('enabled_certificado_third_eye', true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Habilitado', 'enabled_certificado_third_eye', 'enabled_certificado_third_eye_descripcion', 'multi_edit_is_ttr_certificado_third_eye_enabled_certificado_third_eye_search', $editor, $this->dataset, $lookupDataset, 'enabled_certificado_third_eye', 'descripcion', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for certificado_third_eye field
            //
            $editor = new TextEdit('certificado_third_eye_edit');
            $editColumn = new CustomEditColumn('Certificado', 'certificado_third_eye', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for id_empresa field
            //
            $editor = new DynamicCombobox('id_empresa_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_empresa`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id_empresa', true, true),
                    new StringField('empresa'),
                    new StringField('razon_social'),
                    new StringField('rut'),
                    new StringField('direccion'),
                    new StringField('telefono_empresa'),
                    new StringField('enabled_empresa'),
                    new DateTimeField('registro'),
                    new DateTimeField('ingreso'),
                    new StringField('nombre_contacto'),
                    new StringField('telefono_contacto'),
                    new IntegerField('user_id_default'),
                    new IntegerField('monto_deuda'),
                    new StringField('notificacion_sistema'),
                    new StringField('notificacion_email')
                )
            );
            $lookupDataset->setOrderByField('empresa', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Id Empresa', 'id_empresa', 'id_empresa_empresa', 'multi_edit_is_ttr_certificado_third_eye_id_empresa_search', $editor, $this->dataset, $lookupDataset, 'id_empresa', 'empresa', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
        }
    
        protected function AddInsertColumns(Grid $grid)
        {
            //
            // Edit column for patente_vehiculo field
            //
            $editor = new TextEdit('patente_vehiculo_edit');
            $editor->SetMaxLength(7);
            $editColumn = new CustomEditColumn('Patente Vehículo', 'patente_vehiculo', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for modelo_vehiculo field
            //
            $editor = new TextAreaEdit('modelo_vehiculo_edit', 50, 8);
            $editColumn = new CustomEditColumn('Modelo Vehículo', 'modelo_vehiculo', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for third_eye_type_id field
            //
            $editor = new DynamicCombobox('third_eye_type_id_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_third_eye_type`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('third_eye_type_id', true, true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Tipo de Tercer Ojo', 'third_eye_type_id', 'third_eye_type_id_descripcion', 'insert_is_ttr_certificado_third_eye_third_eye_type_id_search', $editor, $this->dataset, $lookupDataset, 'third_eye_type_id', 'descripcion', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for instalacion field
            //
            $editor = new DateTimeEdit('instalacion_edit', false, 'd-m-Y');
            $editColumn = new CustomEditColumn('Fecha Instalación', 'instalacion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for calibracion field
            //
            $editor = new DateTimeEdit('calibracion_edit', false, 'd-m-Y');
            $editColumn = new CustomEditColumn('Fecha de Calibración', 'calibracion', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for caduca field
            //
            $editor = new DateTimeEdit('caduca_edit', false, 'd-m-Y');
            $editColumn = new CustomEditColumn('Fecha de Expiración', 'caduca', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for codigo_fabrica field
            //
            $editor = new TextEdit('codigo_fabrica_edit');
            $editor->SetMaxLength(20);
            $editColumn = new CustomEditColumn('Código Fabrica', 'codigo_fabrica', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for registro field
            //
            $editor = new DateTimeEdit('registro_edit', false, 'd-m-Y H:i:s');
            $editColumn = new CustomEditColumn('Registro', 'registro', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for enabled_certificado_third_eye field
            //
            $editor = new DynamicCombobox('enabled_certificado_third_eye_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_enabled_certificado_third_eye`');
            $lookupDataset->addFields(
                array(
                    new StringField('enabled_certificado_third_eye', true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Habilitado', 'enabled_certificado_third_eye', 'enabled_certificado_third_eye_descripcion', 'insert_is_ttr_certificado_third_eye_enabled_certificado_third_eye_search', $editor, $this->dataset, $lookupDataset, 'enabled_certificado_third_eye', 'descripcion', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for certificado_third_eye field
            //
            $editor = new TextEdit('certificado_third_eye_edit');
            $editColumn = new CustomEditColumn('Certificado', 'certificado_third_eye', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for id_empresa field
            //
            $editor = new DynamicCombobox('id_empresa_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_empresa`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id_empresa', true, true),
                    new StringField('empresa'),
                    new StringField('razon_social'),
                    new StringField('rut'),
                    new StringField('direccion'),
                    new StringField('telefono_empresa'),
                    new StringField('enabled_empresa'),
                    new DateTimeField('registro'),
                    new DateTimeField('ingreso'),
                    new StringField('nombre_contacto'),
                    new StringField('telefono_contacto'),
                    new IntegerField('user_id_default'),
                    new IntegerField('monto_deuda'),
                    new StringField('notificacion_sistema'),
                    new StringField('notificacion_email')
                )
            );
            $lookupDataset->setOrderByField('empresa', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Id Empresa', 'id_empresa', 'id_empresa_empresa', 'insert_is_ttr_certificado_third_eye_id_empresa_search', $editor, $this->dataset, $lookupDataset, 'id_empresa', 'empresa', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            $grid->SetShowAddButton(false && $this->GetSecurityInfo()->HasAddGrant());
        }
    
        private function AddMultiUploadColumn(Grid $grid)
        {
    
        }
    
        protected function AddPrintColumns(Grid $grid)
        {
            //
            // View column for patente_vehiculo field
            //
            $column = new TextViewColumn('patente_vehiculo', 'patente_vehiculo', 'Patente Vehículo', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddPrintColumn($column);
            
            //
            // View column for modelo_vehiculo field
            //
            $column = new TextViewColumn('modelo_vehiculo', 'modelo_vehiculo', 'Modelo Vehículo', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddPrintColumn($column);
            
            //
            // View column for descripcion field
            //
            $column = new TextViewColumn('third_eye_type_id', 'third_eye_type_id_descripcion', 'Tipo de Tercer Ojo', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddPrintColumn($column);
            
            //
            // View column for instalacion field
            //
            $column = new DateTimeViewColumn('instalacion', 'instalacion', 'Fecha Instalación', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('Y-m-d');
            $grid->AddPrintColumn($column);
            
            //
            // View column for calibracion field
            //
            $column = new DateTimeViewColumn('calibracion', 'calibracion', 'Fecha de Calibración', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('d-m-Y');
            $grid->AddPrintColumn($column);
            
            //
            // View column for caduca field
            //
            $column = new DateTimeViewColumn('caduca', 'caduca', 'Fecha de Expiración', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('Y-m-d');
            $grid->AddPrintColumn($column);
            
            //
            // View column for codigo_fabrica field
            //
            $column = new TextViewColumn('codigo_fabrica', 'codigo_fabrica', 'Código Fabrica', $this->dataset);
            $column->setNullLabel('');
            $column->SetOrderable(true);
            $grid->AddPrintColumn($column);
            
            //
            // View column for registro field
            //
            $column = new DateTimeViewColumn('registro', 'registro', 'Registro', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('d-m-Y H:i:s');
            $grid->AddPrintColumn($column);
            
            //
            // View column for descripcion field
            //
            $column = new TextViewColumn('enabled_certificado_third_eye', 'enabled_certificado_third_eye_descripcion', 'Habilitado', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddPrintColumn($column);
            
            //
            // View column for certificado_third_eye field
            //
            $column = new TextViewColumn('certificado_third_eye', 'certificado_third_eye', 'Certificado', $this->dataset);
            $column->SetOrderable(true);
            $column->setHrefTemplate('https://forte.isanto.cl:8443/EmiteCertificado/view/thirdEye/CertificadoTercerOjo?id=%id%');
            $column->setTarget('_self');
            $grid->AddPrintColumn($column);
            
            //
            // View column for id field
            //
            $column = new NumberViewColumn('id', 'id', 'Id', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator(',');
            $column->setDecimalSeparator('');
            $grid->AddPrintColumn($column);
            
            //
            // View column for empresa field
            //
            $column = new TextViewColumn('id_empresa', 'id_empresa_empresa', 'Id Empresa', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddPrintColumn($column);
        }
    
        protected function AddExportColumns(Grid $grid)
        {
            //
            // View column for patente_vehiculo field
            //
            $column = new TextViewColumn('patente_vehiculo', 'patente_vehiculo', 'Patente Vehículo', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddExportColumn($column);
            
            //
            // View column for modelo_vehiculo field
            //
            $column = new TextViewColumn('modelo_vehiculo', 'modelo_vehiculo', 'Modelo Vehículo', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddExportColumn($column);
            
            //
            // View column for descripcion field
            //
            $column = new TextViewColumn('third_eye_type_id', 'third_eye_type_id_descripcion', 'Tipo de Tercer Ojo', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddExportColumn($column);
            
            //
            // View column for instalacion field
            //
            $column = new DateTimeViewColumn('instalacion', 'instalacion', 'Fecha Instalación', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('Y-m-d');
            $grid->AddExportColumn($column);
            
            //
            // View column for calibracion field
            //
            $column = new DateTimeViewColumn('calibracion', 'calibracion', 'Fecha de Calibración', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('d-m-Y');
            $grid->AddExportColumn($column);
            
            //
            // View column for caduca field
            //
            $column = new DateTimeViewColumn('caduca', 'caduca', 'Fecha de Expiración', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('Y-m-d');
            $grid->AddExportColumn($column);
            
            //
            // View column for codigo_fabrica field
            //
            $column = new TextViewColumn('codigo_fabrica', 'codigo_fabrica', 'Código Fabrica', $this->dataset);
            $column->setNullLabel('');
            $column->SetOrderable(true);
            $grid->AddExportColumn($column);
            
            //
            // View column for registro field
            //
            $column = new DateTimeViewColumn('registro', 'registro', 'Registro', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('d-m-Y H:i:s');
            $grid->AddExportColumn($column);
            
            //
            // View column for descripcion field
            //
            $column = new TextViewColumn('enabled_certificado_third_eye', 'enabled_certificado_third_eye_descripcion', 'Habilitado', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddExportColumn($column);
            
            //
            // View column for certificado_third_eye field
            //
            $column = new TextViewColumn('certificado_third_eye', 'certificado_third_eye', 'Certificado', $this->dataset);
            $column->SetOrderable(true);
            $column->setHrefTemplate('https://forte.isanto.cl:8443/EmiteCertificado/view/thirdEye/CertificadoTercerOjo?id=%id%');
            $column->setTarget('_self');
            $grid->AddExportColumn($column);
            
            //
            // View column for id field
            //
            $column = new NumberViewColumn('id', 'id', 'Id', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator(',');
            $column->setDecimalSeparator('');
            $grid->AddExportColumn($column);
            
            //
            // View column for empresa field
            //
            $column = new TextViewColumn('id_empresa', 'id_empresa_empresa', 'Id Empresa', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddExportColumn($column);
        }
    
        private function AddCompareColumns(Grid $grid)
        {
            //
            // View column for patente_vehiculo field
            //
            $column = new TextViewColumn('patente_vehiculo', 'patente_vehiculo', 'Patente Vehículo', $this->dataset);
            $column->SetOrderable(true);
            $grid->AddCompareColumn($column);
            
            //
            // View column for modelo_vehiculo field
            //
            $column = new TextViewColumn('modelo_vehiculo', 'modelo_vehiculo', 'Modelo Vehículo', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddCompareColumn($column);
            
            //
            // View column for descripcion field
            //
            $column = new TextViewColumn('third_eye_type_id', 'third_eye_type_id_descripcion', 'Tipo de Tercer Ojo', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddCompareColumn($column);
            
            //
            // View column for instalacion field
            //
            $column = new DateTimeViewColumn('instalacion', 'instalacion', 'Fecha Instalación', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('Y-m-d');
            $grid->AddCompareColumn($column);
            
            //
            // View column for calibracion field
            //
            $column = new DateTimeViewColumn('calibracion', 'calibracion', 'Fecha de Calibración', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('d-m-Y');
            $grid->AddCompareColumn($column);
            
            //
            // View column for caduca field
            //
            $column = new DateTimeViewColumn('caduca', 'caduca', 'Fecha de Expiración', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('Y-m-d');
            $grid->AddCompareColumn($column);
            
            //
            // View column for codigo_fabrica field
            //
            $column = new TextViewColumn('codigo_fabrica', 'codigo_fabrica', 'Código Fabrica', $this->dataset);
            $column->setNullLabel('');
            $column->SetOrderable(true);
            $grid->AddCompareColumn($column);
            
            //
            // View column for registro field
            //
            $column = new DateTimeViewColumn('registro', 'registro', 'Registro', $this->dataset);
            $column->SetOrderable(true);
            $column->SetDateTimeFormat('d-m-Y H:i:s');
            $grid->AddCompareColumn($column);
            
            //
            // View column for descripcion field
            //
            $column = new TextViewColumn('enabled_certificado_third_eye', 'enabled_certificado_third_eye_descripcion', 'Habilitado', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddCompareColumn($column);
            
            //
            // View column for certificado_third_eye field
            //
            $column = new TextViewColumn('certificado_third_eye', 'certificado_third_eye', 'Certificado', $this->dataset);
            $column->SetOrderable(true);
            $column->setHrefTemplate('https://forte.isanto.cl:8443/EmiteCertificado/view/thirdEye/CertificadoTercerOjo?id=%id%');
            $column->setTarget('_self');
            $grid->AddCompareColumn($column);
            
            //
            // View column for empresa field
            //
            $column = new TextViewColumn('id_empresa', 'id_empresa_empresa', 'Id Empresa', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $grid->AddCompareColumn($column);
        }
    
        private function AddCompareHeaderColumns(Grid $grid)
        {
    
        }
    
        public function GetPageDirection()
        {
            return null;
        }
    
        public function isFilterConditionRequired()
        {
            return false;
        }
    
        protected function ApplyCommonColumnEditProperties(CustomEditColumn $column)
        {
            $column->SetDisplaySetToNullCheckBox(false);
            $column->SetDisplaySetToDefaultCheckBox(false);
    		$column->SetVariableContainer($this->GetColumnVariableContainer());
        }
    
        function GetCustomClientScript()
        {
            return ;
        }
        
        function GetOnPageLoadedClientScript()
        {
            return ;
        }
    
        protected function CreateGrid()
        {
            $result = new Grid($this, $this->dataset);
            if ($this->GetSecurityInfo()->HasDeleteGrant())
               $result->SetAllowDeleteSelected(false);
            else
               $result->SetAllowDeleteSelected(false);   
            
            ApplyCommonPageSettings($this, $result);
            
            $result->SetUseImagesForActions(true);
            $result->SetUseFixedHeader(false);
            $result->SetShowLineNumbers(false);
            $result->SetShowKeyColumnsImagesInHeader(false);
            $result->setAllowSortingByDialog(false);
            $result->SetViewMode(ViewMode::TABLE);
            $result->setEnableRuntimeCustomization(false);
            $result->setSelectionFilterAllowed(false);
            $result->setMultiEditAllowed($this->GetSecurityInfo()->HasEditGrant() && false);
            $result->setTableBordered(false);
            $result->setTableCondensed(false);
            
            $result->SetHighlightRowAtHover(false);
            $result->SetWidth('');
            $this->AddOperationsColumns($result);
            $this->AddFieldColumns($result);
            $this->AddSingleRecordViewColumns($result);
            $this->AddEditColumns($result);
            $this->AddMultiEditColumns($result);
            $this->AddInsertColumns($result);
            $this->AddPrintColumns($result);
            $this->AddExportColumns($result);
            $this->AddMultiUploadColumn($result);
    
    
            $this->SetShowPageList(false);
            $this->SetShowTopPageNavigator(false);
            $this->SetShowBottomPageNavigator(true);
            $this->setPrintListAvailable(false);
            $this->setPrintListRecordAvailable(false);
            $this->setPrintOneRecordAvailable(false);
            $this->setAllowPrintSelectedRecords(false);
            $this->setExportListAvailable(array());
            $this->setExportSelectedRecordsAvailable(array());
            $this->setExportListRecordAvailable(array());
            $this->setExportOneRecordAvailable(array());
            $this->setOpenExportedPdfInNewTab(false);
            $this->setModalViewSize(Modal::SIZE_SM);
            $this->setModalFormSize(Modal::SIZE_SM);
            $this->SetHidePageListByDefault(true);
    
            return $result;
        }
     
        protected function setClientSideEvents(Grid $grid) {
    
        }
    
        protected function doRegisterHandlers() {
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_third_eye_type`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('third_eye_type_id', true, true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_is_ttr_certificado_third_eye_third_eye_type_id_search', 'third_eye_type_id', 'descripcion', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_enabled_certificado_third_eye`');
            $lookupDataset->addFields(
                array(
                    new StringField('enabled_certificado_third_eye', true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_is_ttr_certificado_third_eye_enabled_certificado_third_eye_search', 'enabled_certificado_third_eye', 'descripcion', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_empresa`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id_empresa', true, true),
                    new StringField('empresa'),
                    new StringField('razon_social'),
                    new StringField('rut'),
                    new StringField('direccion'),
                    new StringField('telefono_empresa'),
                    new StringField('enabled_empresa'),
                    new DateTimeField('registro'),
                    new DateTimeField('ingreso'),
                    new StringField('nombre_contacto'),
                    new StringField('telefono_contacto'),
                    new IntegerField('user_id_default'),
                    new IntegerField('monto_deuda'),
                    new StringField('notificacion_sistema'),
                    new StringField('notificacion_email')
                )
            );
            $lookupDataset->setOrderByField('empresa', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_is_ttr_certificado_third_eye_id_empresa_search', 'id_empresa', 'empresa', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_third_eye_type`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('third_eye_type_id', true, true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_is_ttr_certificado_third_eye_third_eye_type_id_search', 'third_eye_type_id', 'descripcion', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_enabled_certificado_third_eye`');
            $lookupDataset->addFields(
                array(
                    new StringField('enabled_certificado_third_eye', true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_is_ttr_certificado_third_eye_enabled_certificado_third_eye_search', 'enabled_certificado_third_eye', 'descripcion', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_empresa`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id_empresa', true, true),
                    new StringField('empresa'),
                    new StringField('razon_social'),
                    new StringField('rut'),
                    new StringField('direccion'),
                    new StringField('telefono_empresa'),
                    new StringField('enabled_empresa'),
                    new DateTimeField('registro'),
                    new DateTimeField('ingreso'),
                    new StringField('nombre_contacto'),
                    new StringField('telefono_contacto'),
                    new IntegerField('user_id_default'),
                    new IntegerField('monto_deuda'),
                    new StringField('notificacion_sistema'),
                    new StringField('notificacion_email')
                )
            );
            $lookupDataset->setOrderByField('empresa', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_is_ttr_certificado_third_eye_id_empresa_search', 'id_empresa', 'empresa', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_third_eye_type`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('third_eye_type_id', true, true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_is_ttr_certificado_third_eye_third_eye_type_id_search', 'third_eye_type_id', 'descripcion', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_enabled_certificado_third_eye`');
            $lookupDataset->addFields(
                array(
                    new StringField('enabled_certificado_third_eye', true, true),
                    new StringField('descripcion', true),
                    new DateTimeField('record_date', true)
                )
            );
            $lookupDataset->setOrderByField('descripcion', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_is_ttr_certificado_third_eye_enabled_certificado_third_eye_search', 'enabled_certificado_third_eye', 'descripcion', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                MySqlIConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '`is_tpa_empresa`');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id_empresa', true, true),
                    new StringField('empresa'),
                    new StringField('razon_social'),
                    new StringField('rut'),
                    new StringField('direccion'),
                    new StringField('telefono_empresa'),
                    new StringField('enabled_empresa'),
                    new DateTimeField('registro'),
                    new DateTimeField('ingreso'),
                    new StringField('nombre_contacto'),
                    new StringField('telefono_contacto'),
                    new IntegerField('user_id_default'),
                    new IntegerField('monto_deuda'),
                    new StringField('notificacion_sistema'),
                    new StringField('notificacion_email')
                )
            );
            $lookupDataset->setOrderByField('empresa', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_is_ttr_certificado_third_eye_id_empresa_search', 'id_empresa', 'empresa', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
        }
       
        protected function doCustomRenderColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderPrintColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderExportColumn($exportType, $fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomDrawRow($rowData, &$cellFontColor, &$cellFontSize, &$cellBgColor, &$cellItalicAttr, &$cellBoldAttr)
        {
    
        }
    
        protected function doExtendedCustomDrawRow($rowData, &$rowCellStyles, &$rowStyles, &$rowClasses, &$cellClasses)
        {
    
        }
    
        protected function doCustomRenderTotal($totalValue, $aggregate, $columnName, &$customText, &$handled)
        {
    
        }
    
        protected function doCustomDefaultValues(&$values, &$handled) 
        {
    
        }
    
        protected function doCustomCompareColumn($columnName, $valueA, $valueB, &$result)
        {
    
        }
    
        protected function doBeforeInsertRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeUpdateRecord($page, $oldRowData, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeDeleteRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterInsertRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterUpdateRecord($page, $oldRowData, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterDeleteRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doCustomHTMLHeader($page, &$customHtmlHeaderText)
        { 
    
        }
    
        protected function doGetCustomTemplate($type, $part, $mode, &$result, &$params)
        {
    
        }
    
        protected function doGetCustomExportOptions(Page $page, $exportType, $rowData, &$options)
        {
    
        }
    
        protected function doFileUpload($fieldName, $rowData, &$result, &$accept, $originalFileName, $originalFileExtension, $fileSize, $tempFileName)
        {
    
        }
    
        protected function doPrepareChart(Chart $chart)
        {
    
        }
    
        protected function doPrepareColumnFilter(ColumnFilter $columnFilter)
        {
    
        }
    
        protected function doPrepareFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
    
        }
    
        protected function doGetSelectionFilters(FixedKeysArray $columns, &$result)
        {
    
        }
    
        protected function doGetCustomFormLayout($mode, FixedKeysArray $columns, FormLayout $layout)
        {
    
        }
    
        protected function doGetCustomColumnGroup(FixedKeysArray $columns, ViewColumnGroup $columnGroup)
        {
    
        }
    
        protected function doPageLoaded()
        {
    
        }
    
        protected function doCalculateFields($rowData, $fieldName, &$value)
        {
    
        }
    
        protected function doGetCustomRecordPermissions(Page $page, &$usingCondition, $rowData, &$allowEdit, &$allowDelete, &$mergeWithDefault, &$handled)
        {
    
        }
    
        protected function doAddEnvironmentVariables(Page $page, &$variables)
        {
    
        }
    
    }

    SetUpUserAuthorization();

    try
    {
        $Page = new is_ttr_certificado_third_eyePage("is_ttr_certificado_third_eye", "is_ttr_certificado_third_eye.php", GetCurrentUserPermissionsForPage("is_ttr_certificado_third_eye"), 'UTF-8');
        $Page->SetRecordPermission(GetCurrentUserRecordPermissionsForDataSource("is_ttr_certificado_third_eye"));
        GetApplication()->SetMainPage($Page);
        GetApplication()->Run();
    }
    catch(Exception $e)
    {
        ShowErrorPage($e);
    }
	
